﻿using GenLib.Document;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace DocsGenTest.EndToEnd
{
    [TestClass]
    public class ComplexTemplateTest
    {
        [TestMethod]
        [DataRow("..\\..\\test_scenario\\06_ComplexTemplate\\correct\\1", "..\\..\\test_data\\example_input_data_correct_2.json")]
        public void Generate_CorrectGeneration_CorrectDocument_1(string folderPath, string inputDataPath)
        {
            TestUtil.ResolveFullFilePaths(folderPath, inputDataPath, out string templateFullPath,
            out string currentDocumentFullPath, out string expectedDocumentFullPath, out string inputDataFullPath);

            TestUtil.GenerateCurrentDocument(templateFullPath, currentDocumentFullPath, inputDataFullPath);

            Assert.IsTrue(TestUtil.AreDocumentsSame(currentDocumentFullPath, expectedDocumentFullPath));
        }

        [TestMethod]
        [DataRow("..\\..\\test_scenario\\06_ComplexTemplate\\correct\\2", "..\\..\\test_data\\example_input_data_correct_2.json")]
        public void Generate_CorrectGeneration_CorrectDocument_2(string folderPath, string inputDataPath)
        {
            TestUtil.ResolveFullFilePaths(folderPath, inputDataPath, out string templateFullPath,
            out string currentDocumentFullPath, out string expectedDocumentFullPath, out string inputDataFullPath);

            TestUtil.GenerateCurrentDocument(templateFullPath, currentDocumentFullPath, inputDataFullPath);

            Assert.IsTrue(TestUtil.AreDocumentsSame(currentDocumentFullPath, expectedDocumentFullPath));
        }

        [TestCleanup]
        public void CleanUp()
        {
            DocumentManager documentManager = DocumentManager.Instance;
            documentManager.Close();
            documentManager.CloseWordProcesses();
        }
    }
}
