﻿using GenLib;
using GenLib.Document;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace DocsGenTest.EndToEnd
{
    [TestClass]
    public class FormatDateMethodTest
    {
        [TestMethod]
        [DataRow("..\\..\\test_scenario\\05_FormatDateMethod\\correct", "..\\..\\test_data\\example_input_data_correct_1.json")]
        public void Generate_CorrectGeneration_CorrectDocument(string folderPath, string inputDataPath)
        {
            TestUtil.ResolveFullFilePaths(folderPath, inputDataPath, out string templateFullPath,
            out string currentDocumentFullPath, out string expectedDocumentFullPath, out string inputDataFullPath);

            TestUtil.GenerateCurrentDocument(templateFullPath, currentDocumentFullPath, inputDataFullPath);

            Assert.IsTrue(TestUtil.AreDocumentsSame(currentDocumentFullPath, expectedDocumentFullPath));
        }

        [TestMethod]
        [DataRow("..\\..\\test_scenario\\05_FormatDateMethod\\error", "..\\..\\test_data\\example_input_data_correct_1.json")]
        [ExpectedException(typeof(DateTimeFormatException))]
        public void Generate_IncorrectGeneration_AntlrSyntaxException(string folderPath, string inputDataPath)
        {
            TestUtil.ResolveFullFilePaths(folderPath, inputDataPath, out string templateFullPath,
            out string currentDocumentFullPath, out _, out string inputDataFullPath);

            TestUtil.GenerateCurrentDocument(templateFullPath, currentDocumentFullPath, inputDataFullPath);
        }

        [TestCleanup]
        public void CleanUp()
        {
            DocumentManager documentManager = DocumentManager.Instance;
            documentManager.Close();
            documentManager.CloseWordProcesses();
        }
    }
}
