﻿using GenLib.Document;
using GroupDocs.Comparison;
using GroupDocs.Comparison.Result;
using System.IO;

namespace DocsGenTest.EndToEnd
{
    public static class TestUtil
    {
        public static bool AreDocumentsSame(string document1Path, string document2Path)
        {
            Comparer comparer = new Comparer(document1Path);

            comparer.Add(document2Path);

            comparer.Compare();

            ChangeInfo[] changes = comparer.GetChanges();

            if (changes == null || changes.Length <= 0)
            {
                return true;
            }

            return false;
        }

        public static void ResolveFullFilePaths(string folderPath, string inputDataPath, out string templateFullPath, 
            out string currentDocumentFullPath, out string expectedDocumentFullPath, out string inputDataFullPath)
        {
            string templatePath = folderPath + "\\template.docx";
            string currentDocumentPath = folderPath + "\\current_document.docx";
            string expectedDocumentPath = folderPath + "\\expected_document.docx";

            templateFullPath = Path.GetFullPath(templatePath);
            currentDocumentFullPath = Path.GetFullPath(currentDocumentPath);
            expectedDocumentFullPath = Path.GetFullPath(expectedDocumentPath);
            inputDataFullPath = Path.GetFullPath(inputDataPath);
        }

        internal static void GenerateCurrentDocument(string templateFullPath, string currentDocumentFullPath, string inputDataFullPath)
        {
            DocumentManager documentManager = DocumentManager.Instance;
            documentManager.LoadTempTemplateFromFile(templateFullPath);
            documentManager.Preprocess();
            documentManager.CreateDocument(currentDocumentFullPath);
            documentManager.GenerateDocument(inputDataFullPath);
            documentManager.Close();
            documentManager.CloseWordProcesses();
        }
    }
}
