﻿using GenLib;
using GenLib.Data;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace DocsGenTest.Unit
{
    [TestClass]
    public class DataLoaderTest
    {
        [TestMethod]
        [DataRow("..\\..\\test_data\\example_input_data_correct_1.json")]
        public void LoadDataJson_WellFormedJSON_True(string filePathJson)
        {
            DataLoader dataLoader = new DataLoader(filePathJson);
            dataLoader.LoadDataJson();

            Assert.IsNotNull(dataLoader.Root);
        }

        [TestMethod]
        [DataRow("..\\..\\test_data\\example_input_data_wrong.json")]
        [ExpectedException(typeof(DataException))]
        public void LoadDataJson_NonWellFormedJSON_DataException(string filePathJson)
        {
            DataLoader dataLoader = new DataLoader(filePathJson);
            dataLoader.LoadDataJson();
        }
    }
}
