﻿using GenLib.Entity;

namespace GenLib.Builder
{
    /// <summary>
    /// This class is Builder class for EscapedCharBuilder entity.
    /// It provides to going through the parsing tree.
    /// </summary>
    class EscapedCharBuilder : Builder
    {
        /// <summary>
        /// This property contains EscapedChar entity.
        /// </summary>
        public EscapedChar EscapedChar { get; set; }

        /// <summary>
        /// Constructor of the EscapedCharBuilder class.
        /// </summary>
        /// <param name="escapedChar">EscapedChar entity.</param>
        public EscapedCharBuilder(EscapedChar escapedChar)
        {
            EscapedChar = escapedChar;
        }

        /// <summary>
        /// This method adds escaped character to final text of generated
        /// document.
        /// </summary>
        public void Build()
        {
            AddChar(EscapedChar.Character);
        }
    }
}
