﻿using GenLib.Data;
using GenLib.Entity;

namespace GenLib.Builder
{
    /// <summary>
    /// This class is Builder class for Parse entity (this entity is Root of the parsing tree).
    /// It provides to going through the parsing tree.
    /// </summary>
    class ParseBuilder : Builder
    {
        /// <summary>
        /// This property contains Parse entity.
        /// </summary>
        public Parse Parse { get; set; }

        /// <summary>
        /// Constructor of the ParseBuiler class.
        /// </summary>
        /// <param name="parse">Parse entity.</param>
        /// <param name="dataRoot">Root of the input data.</param>
        public ParseBuilder(Parse parse, DataObject dataRoot)
        {
            Parse = parse;
            DataRoot = dataRoot;
        }

        /// <summary>
        /// This method calls going through the parsing tree 
        /// for the Block entity of this Parse entity.
        /// </summary>
        public void Build()
        {
            Block block = Parse.Block;

            new BlockBuilder(block).Build();
        }
    }
}
