﻿using System.Collections.Generic;

namespace GenLib.Entity
{
    /// <summary>
    /// Block entity. It relates with 'block' rule in the grammar.
    /// </summary>
    public class Block : Base
    {
        /// <summary>
        /// This property contains list of Atom entitites in this Block entity context.
        /// </summary>
        public List<Atom> Atoms { get; private set; }

        /// <summary>
        /// This property contains dictionary of controlling variables in this Block entity context.
        /// </summary>
        public Dictionary<string, ControllingVariable> controllingVariables = new Dictionary<string, ControllingVariable>();

        /// <summary>
        /// Constructor of the Block class.
        /// </summary>
        /// <param name="atoms">List of Atom entitites in this Block entity context.</param>
        public Block(List<Atom> atoms)
        {
            Atoms = atoms;
            Atoms.Reverse();
        }
    }
}
