﻿using GenLib.Data;

namespace GenLib.Entity
{
    /// <summary>
    /// This class is entity for controlling variable for foreach and tableforeach directive.
    /// </summary>
    public class ControllingVariable
    {
        /// <summary>
        /// Identifier of the controlling variable.
        /// </summary>
        public string Identificator { get; set; }

        /// <summary>
        /// Data object relates with the controlling variable.
        /// </summary>
        public DataObject DataObject { get; set; }

        /// <summary>
        /// Constructor of the ControllingVariable class.
        /// </summary>
        /// <param name="ident">Identifier of the controlling variable.</param>
        public ControllingVariable(string ident)
        {
            Identificator = ident;
        }
    }

}
