﻿using GenLib.Entity.Enum;

namespace GenLib.Entity
{
    /// <summary>
    /// This abstract class realizes Directive entity. It relates with 'directive' rule in the grammar.
    /// </summary>
    public abstract class Directive : Atom
    {
        /// <summary>
        /// This property contains specific type of Directive entity.
        /// </summary>
        public EDirectiveType DirectiveType { get; set; }

        /// <summary>
        /// Constructor of the Directive class.
        /// </summary>
        public Directive()
        {
            Type = EAtomType.DIRECTIVE;
        }
    }
}
