﻿namespace GenLib.Entity
{
    /// <summary>
    /// Text entity. It relates with 'TEXT' rule in the grammar.
    /// </summary>
    class Text : Atom
    {
        /// <summary>
        /// This property contains one character of the text.
        /// </summary>
        public char Character { get; set; }

        /// <summary>
        /// Constructor of the Text class.
        /// </summary>
        /// <param name="character">Character of the text.</param>
        public Text(char character)
        {
            Character = character;
            Type = EAtomType.TEXT;
        }

    }
}
