parser grammar DocsGenParser;

options {
  tokenVocab=DocsGenLexer;
}

parse
 : block EOF
 ;

block
 : atom*
 ;

atom
 : TEXT
 | ESCAPED_CHAR
 | variable
 | formal
 | property_or_method
 | directive
 ;

formal
 : DOLLAR_OBRACE formal_property_or_method CBRACE
 | DOLLAR_OBRACE id CBRACE
 ;

variable
 : DOLLAR id DOT?
 | REFERENCE DOT?
 ;

property_or_method
 : variable property_end+
 ;

formal_property_or_method
 : id property_end+
 ;

directive
 : foreach_directive
 | tableforeach_directive
 | include_directive
 ;

property_end
 : DOT ID
 | OPAR parameters? CPAR
 ;

parameters
 : parameter
 ;

foreach_directive
 : FOREACH variable K_IN property_or_method CPAR block end
 ;

tableforeach_directive
 : TABLEFOREACH variable K_IN property_or_method CPAR block end
 ;

include_directive
 : INCLUDE STRING CPAR
 ;

end
 : END
 ;

parameter
 : STRING
 | INTEGER
 ;

id
 : ID
 | K_IN
 ;
