﻿using GenLib.Entity;
using System;

namespace GenLib.Methods
{
    /// <summary>
    /// This static class provides to processing defined methods in Word document.
    /// </summary>
    public static class MethodsLib
    {
        /// <summary>
        /// This method processes the Current Date method.
        /// </summary>
        /// <returns>String of the current date.</returns>
        public static string MethodCurrentDate()
        {
            DateTime localDate = DateTime.Now;
            return localDate.ToString("dd.MM.yyyy");
        }

        /// <summary>
        /// This method processes the Format Date method.
        /// </summary>
        /// <param name="input">Date to format.</param>
        /// <param name="parameter">Required format of the date.</param>
        /// <returns>String of the formatted date.</returns>
        public static string MethodFormatDate(string input, Parameter parameter)
        {
            DateTime date;

            if (!DateTime.TryParse(input, out date))
            {
                throw new DateTimeFormatException(ErrorType.DATETIME_VALUE_NOT_VALID);
            }

            if (parameter.ValueStr == null || parameter.ValueStr.Equals(""))
            {
                throw new DateTimeFormatException(ErrorType.DATETIME_FORMAT_NOT_VALID);
            }

            string dateFormat = parameter.ValueStr;
            string convertedDateString = date.ToString(dateFormat);

            if (!DateTime.TryParse(convertedDateString, out date))
            {
                throw new DateTimeFormatException(ErrorType.DATETIME_FORMAT_NOT_VALID);
            }

            return date.ToString(dateFormat);

        }
    }
}
