﻿using Antlr4.Runtime.Misc;
using GenLib.Entity;

namespace GenLib.Visitor
{
    /// <summary>
    /// This class is Visitor class for Parse entity (this entity is Root of the parsing tree).
    /// It provides to create parsing tree using ANTLR interface DocsGenParserBaseVisitor.
    /// </summary>
    class ParseVisitor : DocsGenParserBaseVisitor<Parse>
    {
        /// <summary>
        /// This method creates Parse entity and specified attributes necessary for this entity.
        /// Then this method calls processing of Block entity.
        /// </summary>
        /// <param name="context">Context of Parse entity.</param>
        /// <returns>New Parse entity.</returns>
        public override Parse VisitParse([NotNull] DocsGenParser.ParseContext context)
        {
            Block block = new BlockVisitor().Visit(context.block());

            return new Parse(block);
        }
    }
}
