﻿using System;
using System.Drawing;

namespace TemplateBuilder.Model.Utils
{
    /// <summary>
    /// This class contains method for convert MS Office Image into WinForms Image.
    /// </summary>
    public sealed class ImageConvertor : System.Windows.Forms.AxHost
    {
        /// <summary>
        /// Constructor of the ImageConvertor class.
        /// </summary>
        private ImageConvertor() : base(null) { }

        /// <summary>
        /// This method provides to get IPictureDisp from Image.
        /// </summary>
        /// <param name="image">Image to convert.</param>
        /// <returns>Instance of IPictureDisp.</returns>
        public static stdole.IPictureDisp Convert(Image image)
        {
            return (stdole.IPictureDisp)GetIPictureDispFromPicture(image);
        }

        /// <summary>
        /// This method provides to get Image from IPictureDisp.
        /// </summary>
        /// <param name="image">IPictureDisp to convert.</param>
        /// <returns>Instance of Image.</returns>
        public static Image Convert(stdole.IPictureDisp image)
        {
            int type = image.Type;

            if (type == 1)
            {
                IntPtr hPal = (IntPtr)image.hPal;
                return Image.FromHbitmap((IntPtr)image.Handle, hPal);
            }

            return null;
        }
    }
}
